| Flutter Linux Embedder |

Classes | Macros | Enumerations | Functions | Variables
fl_application.cc File Reference
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_application.h"`
`#include <gtk/gtk.h>`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_dart_project.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_plugin_registry.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_view.h"`

Go to the source code of this file.

## Classes
struct | FlApplicationPrivate

## Macros
#define | FL_APPLICATION_GET_PRIVATE(app)

## Enumerations
enum | { SIGNAL_REGISTER_PLUGINS, SIGNAL_CREATE_WINDOW, LAST_SIGNAL }

## Functions
| G_DEFINE_TYPE_WITH_CODE (FlApplication, fl_application, GTK_TYPE_APPLICATION, G_ADD_PRIVATE(FlApplication)) static void first_frame_cb(FlApplication *self
| if (window !=nullptr &&GTK_IS_WINDOW(window))
static void | fl_application_register_plugins (FlApplication *self, FlPluginRegistry *registry)
static GtkWindow * | fl_application_create_window (FlApplication *self, FlView *view)
static void | fl_application_activate (GApplication *application)
static gboolean | fl_application_local_command_line (GApplication *application, gchar ***arguments, int *exit_status)
static void | fl_application_dispose (GObject *object)
static void | fl_application_class_init (FlApplicationClass *klass)
static void | fl_application_init (FlApplication *self)
G_MODULE_EXPORT FlApplication * | fl_application_new (const gchar *application_id, GApplicationFlags flags)

## Variables
static guint | fl_application_signals [LAST_SIGNAL]
FlView * | view

## Macro Definition Documentation

## ◆ FL_APPLICATION_GET_PRIVATE

#define FL_APPLICATION_GET_PRIVATE | ( |  | app | ) |

Value:
((FlApplicationPrivate*)fl_application_get_instance_private( \
FL_APPLICATION(app)))

Definition at line 21 of file fl_application.cc.

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
SIGNAL_REGISTER_PLUGINS |
SIGNAL_CREATE_WINDOW |
LAST_SIGNAL |

Definition at line 25 of file fl_application.cc.

25 { SIGNAL_REGISTER_PLUGINS, SIGNAL_CREATE_WINDOW, LAST_SIGNAL };

## Function Documentation

## ◆ fl_application_activate()

static void fl_application_activate | ( | GApplication * | application | ) |
| static

Definition at line 84 of file fl_application.cc.

84 {
85 FlApplication* self = FL_APPLICATION(application);
86 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
87
88 g_autoptr(FlDartProject) project = fl_dart_project_new();
89 fl_dart_project_set_dart_entrypoint_arguments(
90 project, priv->dart_entrypoint_arguments);
91
92 FlView* view = fl_view_new(project);
93 g_signal_connect_swapped(view, "first-frame", G_CALLBACK(first_frame_cb),
94 self);
95 gtk_widget_show(GTK_WIDGET(view));
96
97 GtkWindow* window;
98 g_signal_emit(self, fl_application_signals[SIGNAL_CREATE_WINDOW], 0, view,
99 &window);
100
101 // Make the resources for the view so rendering can start.
102 // We'll show the view when we have the first frame.
103 gtk_widget_realize(GTK_WIDGET(view));
104
105 g_signal_emit(self, fl_application_signals[SIGNAL_REGISTER_PLUGINS], 0,
106 FL_PLUGIN_REGISTRY(view));
107 }

References first_frame_cb(), FL_APPLICATION_GET_PRIVATE, fl_application_signals, fl_dart_project_new(), fl_dart_project_set_dart_entrypoint_arguments(), fl_view_new(), priv, SIGNAL_CREATE_WINDOW, SIGNAL_REGISTER_PLUGINS, and view.

Referenced by fl_application_class_init().

## ◆ fl_application_class_init()

static void fl_application_class_init | ( | FlApplicationClass * | klass | ) |
| static

Definition at line 144 of file fl_application.cc.

144 {
145 G_APPLICATION_CLASS(klass)->activate = fl_application_activate;
146 G_APPLICATION_CLASS(klass)->local_command_line =
147 fl_application_local_command_line;
148 G_OBJECT_CLASS(klass)->dispose = fl_application_dispose;
149
150 klass->register_plugins = fl_application_register_plugins;
151 klass->create_window = fl_application_create_window;
152
153 fl_application_signals[SIGNAL_REGISTER_PLUGINS] = g_signal_new(
154 "register-plugins", fl_application_get_type(), G_SIGNAL_RUN_LAST,
155 G_STRUCT_OFFSET(FlApplicationClass, register_plugins), nullptr, nullptr,
156 nullptr, G_TYPE_NONE, 1, fl_plugin_registry_get_type());
157 fl_application_signals[SIGNAL_CREATE_WINDOW] = g_signal_new(
158 "create-window", fl_application_get_type(), G_SIGNAL_RUN_LAST,
159 G_STRUCT_OFFSET(FlApplicationClass, create_window),
160 g_signal_accumulator_first_wins, nullptr, nullptr, GTK_TYPE_WINDOW, 1,
161 fl_view_get_type());
162 }

References fl_application_activate(), fl_application_create_window(), fl_application_dispose(), fl_application_local_command_line(), fl_application_register_plugins(), fl_application_signals, SIGNAL_CREATE_WINDOW, and SIGNAL_REGISTER_PLUGINS.

## ◆ fl_application_create_window()

static GtkWindow* fl_application_create_window | ( | FlApplication * | self,
|  | FlView * | view
| ) |  |
| static

Definition at line 49 of file fl_application.cc.

50 {
51 GtkApplicationWindow* window =
52 GTK_APPLICATION_WINDOW(gtk_application_window_new(GTK_APPLICATION(self)));
53
54 // Use a header bar when running in GNOME as this is the common style used
55 // by applications and is the setup most users will be using (e.g. Ubuntu
56 // desktop).
57 // If running on X and not using GNOME then just use a traditional title bar
58 // in case the window manager does more exotic layout, e.g. tiling.
59 // If running on Wayland assume the header bar will work (may need changing
60 // if future cases occur).
61 gboolean use_header_bar = TRUE;
62 #ifdef GDK_WINDOWING_X11
63 GdkScreen* screen = gtk_window_get_screen(GTK_WINDOW(window));
64 if (GDK_IS_X11_SCREEN(screen)) {
65 const gchar* wm_name = gdk_x11_screen_get_window_manager_name(screen);
66 if (g_strcmp0(wm_name, "GNOME Shell") != 0) {
67 use_header_bar = FALSE;
68 }
69 }
70 #endif
71 if (use_header_bar) {
72 GtkHeaderBar* header_bar = GTK_HEADER_BAR(gtk_header_bar_new());
73 gtk_widget_show(GTK_WIDGET(header_bar));
74 gtk_header_bar_set_show_close_button(header_bar, TRUE);
75 gtk_window_set_titlebar(GTK_WINDOW(window), GTK_WIDGET(header_bar));
76 }
77
78 gtk_container_add(GTK_CONTAINER(window), GTK_WIDGET(view));
79
80 return GTK_WINDOW(window);
81 }

References TRUE, and view.

Referenced by fl_application_class_init().

## ◆ fl_application_dispose()

static void fl_application_dispose | ( | GObject * | object | ) |
| static

Definition at line 135 of file fl_application.cc.

135 {
136 FlApplication* self = FL_APPLICATION(object);
137 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
138
139 g_clear_pointer(&priv->dart_entrypoint_arguments, g_strfreev);
140
141 G_OBJECT_CLASS(fl_application_parent_class)->dispose(object);
142 }

References FL_APPLICATION_GET_PRIVATE, and priv.

Referenced by fl_application_class_init().

## ◆ fl_application_init()

static void fl_application_init | ( | FlApplication * | self | ) |
| static

Definition at line 164 of file fl_application.cc.

164 {}

## ◆ fl_application_local_command_line()

static gboolean fl_application_local_command_line | ( | GApplication * | application,
|  | gchar *** | arguments,
|  | int * | exit_status
| ) |  |
| static

Definition at line 110 of file fl_application.cc.

112 {
113 FlApplication* self = FL_APPLICATION(application);
114 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
115
116 // Strip out the first argument as it is the binary name.
117 priv->dart_entrypoint_arguments = g_strdupv(*arguments + 1);
118
119 g_autoptr(GError) error = nullptr;
120 if (!g_application_register(application, nullptr, &error)) {
121 g_warning("Failed to register: %s", error->message);
122 *exit_status = 1;
123 return TRUE;
124 }
125
126 // This will only run on the primary instance or this instance with
127 // G_APPLICATION_NON_UNIQUE
128 g_application_activate(application);
129 *exit_status = 0;
130
131 return TRUE;
132 }

References error, FL_APPLICATION_GET_PRIVATE, priv, and TRUE.

Referenced by fl_application_class_init().

## ◆ fl_application_new()

G_MODULE_EXPORT FlApplication* fl_application_new | ( | const gchar * | application_id,
|  | GApplicationFlags | flags
| ) |  |

FlApplication:

#Flutter-based application with the GTK embedder.

Provides default behaviour for basic Flutter applications. fl_application_new: @application_id: (allow-none): The application ID or NULL. @flags: The application flags.

Creates a new Flutter-based application.

Returns: a new #FlApplication

Definition at line 167 of file fl_application.cc.

168 {
169 return FL_APPLICATION(g_object_new(fl_application_get_type(),
170 "application-id", application_id, "flags",
171 flags, nullptr));
172 }

References flags.

Referenced by TEST().

## ◆ fl_application_register_plugins()

static void fl_application_register_plugins | ( | FlApplication * | self,
|  | FlPluginRegistry * | registry
| ) |  |
| static

Definition at line 45 of file fl_application.cc.

46 {}

Referenced by fl_application_class_init().

## ◆ G_DEFINE_TYPE_WITH_CODE()

G_DEFINE_TYPE_WITH_CODE | ( | FlApplication | ,
|  | fl_application | ,
|  | GTK_TYPE_APPLICATION | ,
|  | G_ADD_PRIVATE(FlApplication) |
| ) |  |

## ◆ if()

if | ( | window ! | = `nullptr && GTK_IS_WINDOW(window)` | ) |

Definition at line 39 of file fl_application.cc.

39 {
40 gtk_window_present(GTK_WINDOW(window));
41 }

## Variable Documentation

## ◆ fl_application_signals

guint fl_application_signals[LAST_SIGNAL]
| static

Definition at line 27 of file fl_application.cc.

Referenced by fl_application_activate(), and fl_application_class_init().

## ◆ view

FlView* view

Initial value:
{
GtkWidget* window = gtk_widget_get_toplevel(GTK_WIDGET(view))

Definition at line 35 of file fl_application.cc.

Referenced by fl_application_activate(), fl_application_create_window(), fl_plugin_registrar_new(), G_DECLARE_FINAL_TYPE(), get_view(), and TEST().

fl_application_activate
static void fl_application_activate(GApplication *application)
Definition: fl_application.cc:84
priv
FlPixelBufferTexturePrivate * priv
Definition: fl_pixel_buffer_texture.cc:30
fl_application_dispose
static void fl_application_dispose(GObject *object)
Definition: fl_application.cc:135
FlApplicationPrivate
Definition: fl_application.cc:16
flags
FlutterSemanticsFlag flags
Definition: fl_accessible_node.cc:106
fl_application_register_plugins
static void fl_application_register_plugins(FlApplication *self, FlPluginRegistry *registry)
Definition: fl_application.cc:45
SIGNAL_REGISTER_PLUGINS
@ SIGNAL_REGISTER_PLUGINS
Definition: fl_application.cc:25
SIGNAL_CREATE_WINDOW
@ SIGNAL_CREATE_WINDOW
Definition: fl_application.cc:25
fl_dart_project_new
G_MODULE_EXPORT FlDartProject * fl_dart_project_new()
Definition: fl_dart_project.cc:50
FL_APPLICATION_GET_PRIVATE
#define FL_APPLICATION_GET_PRIVATE(app)
Definition: fl_application.cc:21
fl_view_new
G_MODULE_EXPORT FlView * fl_view_new(FlDartProject *project)
Definition: fl_view.cc:775
LAST_SIGNAL
@ LAST_SIGNAL
Definition: fl_application.cc:25
fl_dart_project_set_dart_entrypoint_arguments
G_MODULE_EXPORT void fl_dart_project_set_dart_entrypoint_arguments(FlDartProject *self, char **argv)
Definition: fl_dart_project.cc:110
TRUE
return TRUE
Definition: fl_pixel_buffer_texture_test.cc:53
fl_application_create_window
static GtkWindow * fl_application_create_window(FlApplication *self, FlView *view)
Definition: fl_application.cc:49
fl_application_local_command_line
static gboolean fl_application_local_command_line(GApplication *application, gchar ***arguments, int *exit_status)
Definition: fl_application.cc:110
view
FlView * view
Definition: fl_application.cc:35
error
const uint8_t uint32_t uint32_t GError ** error
Definition: fl_pixel_buffer_texture_test.cc:40
fl_application_signals
static guint fl_application_signals[LAST_SIGNAL]
Definition: fl_application.cc:27
first_frame_cb
static void first_frame_cb(FlView *view, gboolean *first_frame_emitted)
Definition: fl_view_test.cc:13